

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn.trainer &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.learn.nn.trainer</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.learn.nn.trainer</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">matplotlib</span>

<span class="kn">import</span> <span class="nn">warnings</span>
<span class="n">warnings</span><span class="o">.</span><span class="n">filterwarnings</span><span class="p">(</span><span class="s2">&quot;ignore&quot;</span><span class="p">,</span> <span class="n">module</span><span class="o">=</span><span class="s2">&quot;matplotlib&quot;</span><span class="p">)</span> <span class="c1"># silence</span>

<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">d2o.utils.errors</span> <span class="kn">as</span> <span class="nn">err</span>
<span class="kn">import</span> <span class="nn">d2o.utils.logger</span> <span class="kn">as</span> <span class="nn">log</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>

<div class="viewcode-block" id="Trainer"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.trainer.Trainer">[docs]</a><span class="k">class</span> <span class="nc">Trainer</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot; Trains the neural network on the supplied dataset &quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">network</span><span class="p">,</span> <span class="n">dataset</span><span class="p">):</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">network</span> <span class="o">=</span> <span class="n">network</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">dataset</span> <span class="o">=</span> <span class="n">dataset</span>

    <span class="n">network</span><span class="o">.</span><span class="n">output_scaler</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">output_scaler</span>
    <span class="n">network</span><span class="o">.</span><span class="n">input_scaler</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">input_scaler</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">targets</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">output_scaler</span><span class="o">.</span><span class="n">inverse_transform</span><span class="p">(</span><span class="n">dataset</span><span class="o">.</span><span class="n">test_targets</span><span class="p">())</span><span class="o">.</span><span class="n">T</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">targets_unscaled</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">test_targets</span><span class="p">()</span><span class="o">.</span><span class="n">T</span>

    <span class="n">target_mask</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">target_mask</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">target_column</span> <span class="o">=</span> <span class="n">target_mask</span><span class="o">.</span><span class="n">masks</span><span class="o">.</span><span class="n">keys</span><span class="p">()[</span><span class="mi">0</span><span class="p">]</span> <span class="c1"># TODO: Remove hardcoded fetching of first column (d2o specific)</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span> <span class="o">=</span> <span class="n">target_mask</span><span class="o">.</span><span class="n">masks</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">target_column</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="c1"># TODO: Remove hardcoded fetching of index 0</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">errors</span> <span class="o">=</span> <span class="p">[]</span>

<div class="viewcode-block" id="Trainer.train_epochs_test"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.trainer.Trainer.train_epochs_test">[docs]</a>  <span class="k">def</span> <span class="nf">train_epochs_test</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">epochs</span><span class="o">=</span><span class="mi">5000</span><span class="p">,</span> <span class="n">learning_rate</span><span class="o">=</span><span class="mf">0.009</span><span class="p">,</span> <span class="n">momentum</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">update_rate</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">min_err</span><span class="o">=</span><span class="mf">1e-3</span><span class="p">,</span> <span class="n">plot</span><span class="o">=</span><span class="bp">True</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Used for testing. Contains plotting functionality &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">plot</span><span class="p">):</span>
      <span class="n">fig</span><span class="p">,</span> <span class="n">axes</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">3</span><span class="p">)</span>
      <span class="n">error_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
      <span class="n">target_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
      <span class="n">output_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

    <span class="n">target_line_unscaled</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">targets_unscaled</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
    <span class="n">output_line_unscaled</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">epochs</span><span class="p">):</span>
      <span class="k">try</span><span class="p">:</span>
        <span class="n">error</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span><span class="o">.</span><span class="n">train_epoch</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset</span><span class="p">,</span> <span class="n">learning_rate</span><span class="o">=</span><span class="n">learning_rate</span><span class="p">,</span> <span class="n">momentum</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">%</span> <span class="n">update_rate</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span>
            <span class="c1"># Bold driver</span>
          <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">1</span><span class="p">):</span>
            <span class="k">if</span> <span class="p">((</span><span class="n">error</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">])</span> <span class="o">&lt;</span> <span class="mi">0</span><span class="p">):</span>
              <span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="o">+</span> <span class="n">learning_rate</span><span class="o">*</span><span class="mf">0.025</span>
              <span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="k">if</span> <span class="p">(</span><span class="n">learning_rate</span> <span class="o">&lt;=</span> <span class="mf">0.99</span><span class="p">)</span> <span class="k">else</span> <span class="mf">0.001</span>
            <span class="k">elif</span> <span class="p">((</span><span class="n">error</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="mi">2</span><span class="p">])</span> <span class="o">&gt;</span> <span class="mf">0.0000000001</span><span class="p">):</span>
              <span class="k">print</span><span class="p">(</span><span class="s2">&quot;Error increased, decreasing learning rate&quot;</span><span class="p">)</span>
              <span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="o">-</span> <span class="n">learning_rate</span><span class="o">*</span><span class="mf">0.50</span>

          <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s1">&#39;error: </span><span class="si">%s</span><span class="s1">, learning_rate: </span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="n">error</span><span class="p">,</span> <span class="n">learning_rate</span><span class="p">))</span>

          <span class="n">diffs</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="n">update_rate</span><span class="p">:]))</span>
          <span class="n">roc</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">diffs</span><span class="p">))</span>

          <span class="n">all_outputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">test_inputs</span><span class="p">())</span>
          <span class="n">all_outputs_unscaled</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">test_inputs</span><span class="p">(),</span> <span class="n">inverse_transform</span><span class="o">=</span><span class="bp">False</span><span class="p">)</span>

          <span class="n">dims</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;t+</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">[</span><span class="n">i</span><span class="p">]:</span><span class="n">all_outputs</span><span class="p">[:,</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">))}</span>
          <span class="n">dims_unscaled</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;t+</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">[</span><span class="n">i</span><span class="p">]:</span><span class="n">all_outputs_unscaled</span><span class="p">[:,</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">))}</span>

          <span class="k">if</span> <span class="p">(</span><span class="n">plot</span><span class="p">):</span>
            <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">([</span><span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">),</span><span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)])</span>
            <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)])</span>

            <span class="n">output_line</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">])),</span> <span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">])</span>
            <span class="n">output_line_unscaled</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">dims_unscaled</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">])),</span> <span class="n">dims_unscaled</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">])</span>

            <span class="k">print</span><span class="p">(</span><span class="n">dims_unscaled</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">][</span><span class="mi">0</span><span class="p">])</span>
            <span class="n">error_line</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)),</span> <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">draw</span><span class="p">()</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">pause</span><span class="p">(</span><span class="mf">0.0000001</span><span class="p">)</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">error</span> <span class="o">&lt;=</span> <span class="n">min_err</span><span class="p">):</span>
          <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Reached minimum after {0} epochs&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">i</span><span class="p">))</span>
          <span class="k">break</span>

      <span class="k">except</span> <span class="ne">KeyboardInterrupt</span><span class="p">:</span>
        <span class="k">print</span><span class="p">(</span><span class="s2">&quot;Terminating&quot;</span><span class="p">)</span>
        <span class="k">break</span>

    <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span></div>

<div class="viewcode-block" id="Trainer.train_epochs"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.trainer.Trainer.train_epochs">[docs]</a>  <span class="k">def</span> <span class="nf">train_epochs</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">epochs</span><span class="o">=</span><span class="mi">5000</span><span class="p">,</span> <span class="n">learning_rate</span><span class="o">=</span><span class="mf">0.009</span><span class="p">,</span> <span class="n">momentum</span><span class="o">=</span><span class="mf">0.5</span><span class="p">,</span> <span class="n">update_rate</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">min_err</span><span class="o">=</span><span class="mf">1e-3</span><span class="p">,</span> <span class="n">plot</span><span class="o">=</span><span class="bp">False</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Train network for the chosen number of epochs.</span>
<span class="sd">    :param epochs: Number of epochs to train for</span>
<span class="sd">    :param learning_rate: Network learning rate</span>
<span class="sd">    :param momentum: Network learning momentum</span>
<span class="sd">    :param update_rate: Update plots and logging every update_rate tick</span>
<span class="sd">    :param min_err: Termination error</span>
<span class="sd">    :param plot: Create and update plots during training, default=False</span>
<span class="sd">    :returns: Trained network</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">if</span> <span class="p">(</span><span class="n">plot</span><span class="p">):</span>
      <span class="n">fig</span><span class="p">,</span><span class="n">axes</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span>
      <span class="n">error_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

      <span class="n">target_7_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
      <span class="n">output_7_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

      <span class="n">target_21_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">2</span><span class="p">],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
      <span class="n">output_21_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

      <span class="n">target_35_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">4</span><span class="p">],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>
      <span class="n">output_35_line</span><span class="p">,</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">plot</span><span class="p">([],</span> <span class="n">linewidth</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span>

      <span class="n">titlesize</span> <span class="o">=</span> <span class="mi">30</span>
      <span class="n">subtitlesize</span> <span class="o">=</span> <span class="mi">20</span>
      <span class="n">plt</span><span class="o">.</span><span class="n">suptitle</span><span class="p">(</span><span class="s1">&#39;</span><span class="si">%s</span><span class="s1"> - </span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">name</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_column</span><span class="p">),</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">titlesize</span><span class="p">)</span>
      <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s1">&#39;Training error&#39;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">subtitlesize</span><span class="p">)</span>
      <span class="n">axes</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s1">&#39;</span><span class="si">%s</span><span class="s1"> (blue), output (green)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_column</span> <span class="o">+</span> <span class="s2">&quot; t+7&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">subtitlesize</span><span class="p">)</span>
      <span class="n">axes</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s1">&#39;</span><span class="si">%s</span><span class="s1"> (blue), output (green)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_column</span> <span class="o">+</span> <span class="s2">&quot; t+21&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">subtitlesize</span><span class="p">)</span>
      <span class="n">axes</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s1">&#39;</span><span class="si">%s</span><span class="s1"> (blue), output (green)&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_column</span> <span class="o">+</span> <span class="s2">&quot; t+35&quot;</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">subtitlesize</span><span class="p">)</span>

      <span class="n">mae_text</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="mf">0.95</span><span class="p">,</span> <span class="mf">0.95</span><span class="p">,</span> <span class="s1">&#39;MAE : {0:.1f}&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">inf</span><span class="p">),</span>
        <span class="n">verticalalignment</span><span class="o">=</span><span class="s1">&#39;bottom&#39;</span><span class="p">,</span> <span class="n">horizontalalignment</span><span class="o">=</span><span class="s1">&#39;right&#39;</span><span class="p">,</span>
        <span class="n">transform</span><span class="o">=</span><span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">subtitlesize</span><span class="p">)</span>
      <span class="n">mape_text</span> <span class="o">=</span> <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">text</span><span class="p">(</span><span class="mf">0.95</span><span class="p">,</span> <span class="mf">0.90</span><span class="p">,</span><span class="s1">&#39;MAPE: {0:.1f}%&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">inf</span><span class="p">),</span>
        <span class="n">verticalalignment</span><span class="o">=</span><span class="s1">&#39;bottom&#39;</span><span class="p">,</span> <span class="n">horizontalalignment</span><span class="o">=</span><span class="s1">&#39;right&#39;</span><span class="p">,</span>
        <span class="n">transform</span><span class="o">=</span><span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">transAxes</span><span class="p">,</span> <span class="n">fontsize</span><span class="o">=</span><span class="n">subtitlesize</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">epochs</span><span class="p">):</span>
      <span class="k">try</span><span class="p">:</span>
        <span class="n">error</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span><span class="o">.</span><span class="n">train_epoch</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset</span><span class="p">,</span> <span class="n">learning_rate</span><span class="o">=</span><span class="n">learning_rate</span><span class="p">,</span> <span class="n">momentum</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">i</span> <span class="o">%</span> <span class="n">update_rate</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span>
          <span class="c1"># Bold driver</span>
          <span class="k">if</span> <span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">):</span>
            <span class="k">if</span> <span class="p">((</span><span class="n">error</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span> <span class="o">&lt;=</span> <span class="mi">0</span><span class="p">):</span>
              <span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="o">+</span> <span class="n">learning_rate</span><span class="o">*</span><span class="mf">0.025</span>
              <span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="k">if</span> <span class="p">(</span><span class="n">learning_rate</span> <span class="o">&lt;=</span> <span class="mf">0.99</span><span class="p">)</span> <span class="k">else</span> <span class="mf">0.001</span>
            <span class="k">elif</span> <span class="p">((</span><span class="n">error</span> <span class="o">-</span> <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span> <span class="o">&gt;</span> <span class="mf">0.0000000001</span><span class="p">):</span>
              <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Error increased, decreasing learning rate&quot;</span><span class="p">)</span>
              <span class="n">learning_rate</span> <span class="o">=</span> <span class="n">learning_rate</span> <span class="o">-</span> <span class="n">learning_rate</span><span class="o">*</span><span class="mf">0.50</span>

          <span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">error</span><span class="p">)</span>
          <span class="n">diffs</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">diff</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">[</span><span class="o">-</span><span class="n">update_rate</span><span class="p">:]))</span>
          <span class="n">roc</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">diffs</span><span class="p">))</span>

          <span class="n">all_outputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">test_inputs</span><span class="p">())</span>
          <span class="n">dims</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;t+</span><span class="si">%s</span><span class="s1">&#39;</span> <span class="o">%</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">[</span><span class="n">i</span><span class="p">]:</span><span class="n">all_outputs</span><span class="p">[:,</span><span class="n">i</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">target_indices</span><span class="p">))}</span>

          <span class="n">abs_err</span> <span class="o">=</span> <span class="n">err</span><span class="o">.</span><span class="n">absolute_error</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
          <span class="n">rel_err</span> <span class="o">=</span> <span class="n">err</span><span class="o">.</span><span class="n">relative_error</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
          <span class="n">per_err</span> <span class="o">=</span> <span class="n">err</span><span class="o">.</span><span class="n">percent_error</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">targets</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>

          <span class="n">top_80</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">abs_err</span><span class="p">)</span><span class="o">*.</span><span class="mi">80</span><span class="p">)</span>
          <span class="n">error_metrics</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;mae&#39;</span><span class="p">:</span><span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="nb">sorted</span><span class="p">(</span><span class="n">abs_err</span><span class="p">)[:</span><span class="n">top_80</span><span class="p">]),</span> <span class="s1">&#39;mape&#39;</span><span class="p">:</span><span class="n">np</span><span class="o">.</span><span class="n">median</span><span class="p">(</span><span class="nb">sorted</span><span class="p">(</span><span class="n">per_err</span><span class="p">)[:</span><span class="n">top_80</span><span class="p">])}</span>
          <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;{0}: {1:.6f} roc: {2:.4f}, lr: {3:.4f}&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">i</span><span class="p">,</span><span class="n">error</span><span class="p">,</span> <span class="n">roc</span><span class="p">,</span> <span class="n">learning_rate</span><span class="p">))</span>

          <span class="k">if</span> <span class="p">(</span><span class="n">plot</span><span class="p">):</span>
            <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">([</span><span class="nb">min</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">),</span><span class="nb">max</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)])</span>
            <span class="n">axes</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">([</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)])</span>

            <span class="n">error_line</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)),</span><span class="bp">self</span><span class="o">.</span><span class="n">errors</span><span class="p">)</span>

            <span class="n">output_7_line</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">])),</span> <span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+7&#39;</span><span class="p">])</span>
            <span class="n">output_21_line</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+21&#39;</span><span class="p">])),</span> <span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+21&#39;</span><span class="p">])</span>
            <span class="n">output_35_line</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span><span class="nb">len</span><span class="p">(</span><span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+35&#39;</span><span class="p">])),</span> <span class="n">dims</span><span class="p">[</span><span class="s1">&#39;t+35&#39;</span><span class="p">])</span>

            <span class="n">mae_text</span><span class="o">.</span><span class="n">set_text</span><span class="p">(</span><span class="s1">&#39;MAE : {0:.1f}&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">error_metrics</span><span class="p">[</span><span class="s1">&#39;mae&#39;</span><span class="p">]))</span>
            <span class="n">mape_text</span><span class="o">.</span><span class="n">set_text</span><span class="p">(</span><span class="s1">&#39;MAPE: {0:.1f}%&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">error_metrics</span><span class="p">[</span><span class="s1">&#39;mape&#39;</span><span class="p">]))</span>

            <span class="n">plt</span><span class="o">.</span><span class="n">draw</span><span class="p">()</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">pause</span><span class="p">(</span><span class="mf">0.0000001</span><span class="p">)</span>

        <span class="k">if</span> <span class="p">(</span><span class="n">error</span> <span class="o">&lt;=</span> <span class="n">min_err</span><span class="p">):</span>
          <span class="n">log</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="s2">&quot;Reached minimum after {0} epochs&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">i</span><span class="p">))</span>
          <span class="k">break</span>

      <span class="k">except</span> <span class="ne">KeyboardInterrupt</span><span class="p">:</span>
        <span class="k">print</span><span class="p">(</span><span class="s2">&quot;Terminating&quot;</span><span class="p">)</span>
        <span class="k">break</span>

    <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">network</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>